<ui:composition xmlns="http://www.w3.org/1999/xhtml"
    xmlns:h="http://java.sun.com/jsf/html"
    xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ui="http://java.sun.com/jsf/facelets"
    xmlns:p="http://primefaces.org/ui"
    xmlns:fn="http://java.sun.com/jsp/jstl/functions">

	<h1>Casastrar de Fornecedores</h1>
	
	<p:tabView id="tbvFornecedores">
		
		<p:tab id="tbCadastro" title="Cadastro">
			<h:form id="form1" enctype="multipart/form-data">
				<h:outputText value="Dados do Fornecedor" style="font-weight: bold" />
				<p:separator title="Fornecedor" />

				<p:panelGrid columns="4" id="panel-dialog" columnClasses="ui-grid-col-1,ui-grid-col-11,ui-grid-col-1,ui-grid-col-11,ui-grid-col-1"
					style="padding-top: 10px;" layout="grid">
					
<!-- 					<p:outputLabel value="Tipo" for="tipoEmpresa" /> -->
<!-- 					<p:selectOneMenu id="tipoEmpresa" value="#{empresaController.empresa.tipo}" disabled="#{!empresaController.ativo}"> -->
<!-- 						<f:selectItems value="#{empresaController.tiposEmpresas}"  -->
<!-- 									   var="tipo" itemLabel="#{tipo.descricao}" -->
<!-- 									   itemValue="${tipo}" /> -->
<!-- 					</p:selectOneMenu> -->
					
					<p:outputLabel value="CNPJ" for="cnpj"/>
                    <p:inputMask disabled="#{!empresaController.ativo}"
                    			mask="99.999.999/9999-99" value="#{empresaController.empresa.cnpj}" id="cnpj">
                    	<p:ajax event="change" update="panelEndereco panel-dialog panel-telefones growl" process="@this"
									listener="#{empresaController.buscarPorCnpj}" onstart="PF('Loading').show()" onsuccess="PF('Loading').hide()"/>
                    </p:inputMask>
                  
					<p:outputLabel value="Razão Social" for="razaoSocial" />
					<p:inputText id="razaoSocial" disabled="#{!empresaController.ativo}"
						value="${empresaController.empresa.razaoSocial}" size="50" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>
					<p:outputLabel value="Nome Fantasia" for="nomeFantasia" />
					<p:inputText id="nomeFantasia" disabled="#{!empresaController.ativo}"
						value="${empresaController.empresa.nomeFantasia}" size="50" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>
					
					<p:outputLabel value="E-mail" for="email" />
					<p:inputText disabled="#{!empresaController.ativo}"
								id="email" size="50" value="#{empresaController.empresa.email}"/>
				
				</p:panelGrid>

				<h:outputText value="Endereço" style="font-weight: bold" />
				<p:separator title="Endereço" />
				
				<!-- painel para adicionar endereco -->
				<p:panelGrid columns="4" id="panelEndereco" layout="grid" columnClasses="ui-grid-col-1,ui-grid-col-11,ui-grid-col-1,ui-grid-col-11">
					<p:outputLabel value="CEP" for="cep" />
					<p:inputMask mask="99999-999" id="cep"
						value="#{empresaController.empresa.endereco.cep}"
						style="width: 70px;" disabled="#{!empresaController.ativo}">
						<p:ajax event="change" update="panelEndereco growl" 
									listener="#{empresaController.buscarEndereco}" />
					</p:inputMask>

					<p:outputLabel value="Logradouro" for="logradouro" />
					<p:inputText id="logradouro"
						value="#{empresaController.empresa.endereco.logradouro}"
						style="width: 300px;" disabled="#{!empresaController.ativo}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Número" for="numero" />
					<p:inputText id="numero"
						value="#{empresaController.empresa.endereco.numero}"
						style="width: 70px;" disabled="#{!empresaController.ativo}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Complemento" for="complemento" />
					<p:inputText id="complemento"
						value="#{empresaController.empresa.endereco.complemento}"
						style="width: 300px;" disabled="#{!empresaController.ativo}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Cidade" for="cidade" />
					<p:autoComplete id="cidade" disabled="#{!empresaController.ativo}"
						completeMethod="#{empresaController.listarCidades}"
						value="#{empresaController.empresa.endereco.cidade}" var="cidade"
						itemLabel="#{cidade.nome}" itemValue="#{cidade}"
						converter="genericConverter" forceSelection="true">
						<p:ajax event="itemSelect" update="panelEndereco"/>
					</p:autoComplete>

					<p:outputLabel value="Bairro" for="bairro" />
					<p:inputText id="bairro" disabled="#{!empresaController.ativo}"
						value="#{empresaController.empresa.endereco.bairro}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Estado" for="uf" />
					<p:inputText id="uf" disabled="true" 
						value="#{empresaController.empresa.endereco.cidade.estado.uf}"
						maxlength="2" style="width: 40px; background-color: #3C8DBC;"/>
				</p:panelGrid>
				<!-- fim painel para adicionar endereco -->

				<h:outputText value="Telefones" style="font-weight: bold" />
				<p:separator title="Telefones" />
				
				<!-- painel para adicionar telefone -->
				<h:panelGrid columns="1" id="panel-telefones" width="300"
					style="padding-bottom: 10px;" >
					<p:commandButton value="Adicionar Telefone" style="width: 60%"
						process="@this" update="panelTelefone" disabled="#{!empresaController.ativo}"
						action="#{clienteController.novoTel}"
						oncomplete="PF('telefoneDialog').show()">
						<p:resetInput target="panelTelefone" />
					</p:commandButton>
					<p:dataTable value="${empresaController.empresa.telefones}" rows="3"
						paginatorAlwaysVisible="true" paginatorPosition="bottom" paginator="true"
						var="telefone" emptyMessage="Nenhum telefone foi adicionado" reflow="true">
						<p:column headerText="Número">
							<h:outputText value="#{telefone.numero}" />
						</p:column>

						<p:column headerText="Ação" width="60">
							<p:commandButton icon="ui-icon-trash" process="@this"
								update=":tbvFornecedores:form1:panel-telefones" id="excluir-fone-button"
								style="width: 45%" disabled="#{!empresaController.ativo}" action="#{empresaController.delTel}">
								<p:confirm header="Remover Telefone" icon="ui-i con-alert"
									message="Você tem certeza que deseja remover este telefone?" />
								<f:setPropertyActionListener value="#{telefone}"
									target="#{empresaController.telefoneSelecionado}" />
							</p:commandButton>
							<p:tooltip for="excluir-fone-button" value="Remover Telefone" />
						</p:column>
					</p:dataTable>
				</h:panelGrid>
				<!-- fim painel para adicionar telefone -->
				
				<!-- comeco dialogo telefone -->
				<p:dialog header="Telefone" widgetVar="telefoneDialog"
					id="dialog-telefone" resizable="false" closeOnEscape="true"
					responsive="true" modal="true">
					<h:panelGroup id="panelTelefone" layout="block"
						styleClass="ui-fluid">
<!-- 						<p:messages id="msgTelefone" autoUpdate="false" /> -->

						<h:panelGrid columns="2" styleClass="panelgrid-noborder">

							<p:outputLabel value="Número" for="numero-fone" />

							<p:inputMask id="numero-fone" mask="?(99) 99999-9999"
								value="#{empresaController.telefone.numero}" />

							<p:outputLabel />
							<p:commandButton value="Inserir Telefone" process="panelTelefone"
								update="panel-telefones panelTelefone growl"
								action="#{empresaController.addTel}"
								oncomplete="if(!args.validationFailed) PF('telefoneDialog').hide()" />

						</h:panelGrid>
					</h:panelGroup>
				</p:dialog>
				<!-- fim dialogo telefone -->
				
				<!-- começo dialogo de confirmação -->
				<p:confirmDialog header="Exclusão"
					message="Tem certeza que deseja excluir?"
					widgetVar="confirmacaoExclusao">
					<p:button value="Não"
						onclick="PF('confirmacaoExclusao').hide(); return false;" />
					<p:commandButton value="Sim"
						oncomplete="PF('confirmacaoExclusao').hide();" />
				</p:confirmDialog>
				<!-- fim dialogo de confirmação -->
				
				<p:toolbar id="tbOpcoes" style="margin-top: 20px">
					<p:toolbarGroup>
						<p:commandButton value="Salvar" id="botaoSalvar"
							action="#{empresaController.salvar}"
							update="form1 growl tbOpcoes"
							rendered="#{empresaController.ativo}"
							process="@this :tbvFornecedores:form1:panel-dialog panelEndereco" />
						<p:commandButton value="Novo" id="botaoNovo"
		    							 actionListener="#{empresaController.ativar}" 
		    							 rendered="#{!empresaController.ativo}"
		    							 update="tbOpcoes panel-dialog panel-telefones panelEndereco" process="@this"/>
		    							 
		    			<p:commandButton value="Cancelar" id="botaoCancelar" 
		    							 rendered="#{empresaController.ativo}"
		    							 actionListener="#{empresaController.desativar}"
		    							 update="tbOpcoes panel-dialog panel-telefones panelEndereco" process="@this">
		    				<p:resetInput target="panel-dialog" />
		    			</p:commandButton>
					</p:toolbarGroup>
				</p:toolbar>
			</h:form>
		</p:tab>
		
		<p:tab id="tabConsulta" title="Consultar">
			<h:form id="form" enctype="multipart/form-data">
    		<h1>Pesquisar</h1>
    		<br/>
    		<h:panelGrid  columns="4" id="panel-consulta" style="padding-top: 10px;">
    		
				<p:outputLabel value="Cnpj: "/>
				<p:inputMask mask="99.999.999/9999-99" value="#{empresaController.pesquisaEmpresa.cnpj}"/>
				
				<p:outputLabel value="Insc. Estadual: "/>
				<p:inputText value="#{empresaController.pesquisaEmpresa.ie}"/>
				
				<p:outputLabel value="Razão Social: "/>
				<p:inputText value="#{empresaController.pesquisaEmpresa.razao}" onkeyup="caps(this)" onblur="caps(this)">
					<p:ajax event="blur" />
				</p:inputText>
				
				<p:outputLabel value="Nome Fantasia: "/>
				<p:inputText value="#{empresaController.pesquisaEmpresa.fantasia}" onkeyup="caps(this)" onblur="caps(this)">
					<p:ajax event="blur" />
				</p:inputText>
				
			</h:panelGrid>
			
			<center><p:commandButton value="Buscar" id="buscar"
   							 actionListener="#{empresaController.consultarEmpresas}" 
   							 update=":tbvFornecedores:form:tblEmpresa growl" process="@this :tbvFornecedores:form:panel-consulta"/></center>
				    		    	
	    	<p:dataTable id="tblEmpresa" emptyMessage="Nenhuma Empresa" paginator="true" value="#{empresaController.listaEmpresas}"
	    			paginatorAlwaysVisible="true" paginatorPosition="bottom" style="margin-top: 20px" var="empresas" rows="4">
	    			    		
	    		<p:column headerText="Nome Fantasia: " >
	    			<h:outputText value="#{empresas.nomeFantasia}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Razão Social: " >
	    			<h:outputText value="#{empresas.razaoSocial}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Cnpj" >
	    			<h:outputText value="#{empresas.cnpj}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Insc. Estadual">
	    			<h:outputText value="#{empresas.ie}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Ações" width="90">
	    			<p:commandButton icon="ui-icon-pencil" title="Editar" onclick="tabView.select(0); return false;"
	    							actionListener="#{empresaController.editar}" update=":tbvFornecedores:form:tblEmpresa">
	  					<f:attribute name="empresaEditada" value="#{empresas}"/>
	    			</p:commandButton>
	    	
	    			<p:commandButton icon="ui-icon-trash" title="Excluir" actionListener="#{empresaController.excluir}" 
	    								update=":tbvFornecedores:form:tblEmpresa growl">
	  					<p:confirm header="Confirmar" message="Desenja excluir Empresa ?" icon="ui-icon-alert"/>
	  					<f:attribute name="empresaExcluida" value="#{empresas}"/>
	    			</p:commandButton>
	    		</p:column>
	    		<f:facet name="footer">
	                <h:outputText value="A Consuta resultou em:  " />
		                <h:outputText value="#{fn:length(empresaController.listaEmpresas) == null ? 0 : fn:length(empresaController.listaEmpresas)}" />
		                <h:outputText value=" Empresas cadastrados. " />
                </f:facet>
	    	</p:dataTable>
			<p:confirmDialog global="true">
				<p:commandButton value="Sim" type="button"
								styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
				<p:commandButton value="Nao" type="button" 
								styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
			</p:confirmDialog>
			</h:form>
		</p:tab>
	</p:tabView>
    
</ui:composition>